<html>
<head>
<title>OGRE: OgreProgressiveMesh.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreProgressiveMesh.h</h1><a href="OgreProgressiveMesh_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">// The underlying algorithms in this class are based heavily on:</span>
<a name="l00030"></a>00030 <span class="comment">/*</span>
<a name="l00031"></a>00031 <span class="comment"> *  Progressive Mesh type Polygon Reduction Algorithm</span>
<a name="l00032"></a>00032 <span class="comment"> *  by Stan Melax (c) 1998</span>
<a name="l00033"></a>00033 <span class="comment"> */</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifndef __ProgressiveMesh_H_</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#define __ProgressiveMesh_H_</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>"</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include "<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>"</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>Ogre {
<a name="l00045"></a>00045 
<a name="l00059"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html">00059</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061     <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3">00064</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3" title="The way to derive the quota of vertices which are reduced at each LOD.">VertexReductionQuota</a>
<a name="l00065"></a>00065         {
<a name="l00067"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e37dcdea89ce8a061d707b04b74a97a3c0">00067</a>             VRQ_CONSTANT,
<a name="l00069"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e38b32f463d36c939a8202f23d91c9b31c">00069</a>             VRQ_PROPORTIONAL
<a name="l00070"></a>00070         };
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">00072</a>         <span class="keyword">typedef</span> std::vector&lt;IndexData*&gt; LODFaceList;
<a name="l00073"></a>00073 
<a name="l00081"></a>00081         <a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* indexData);
<a name="l00082"></a>00082         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>();
<a name="l00083"></a>00083 
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addExtraVertexPositionBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData);
<a name="l00100"></a>00100 
<a name="l00109"></a>00109         <span class="keyword">virtual</span> <span class="keywordtype">void</span> build(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> numLevels, LODFaceList* outList, 
<a name="l00110"></a>00110             <a class="code" href="classOgre_1_1ProgressiveMesh.html#c8ade932d6a3a6b24c7b7ad33c32a8e3" title="The way to derive the quota of vertices which are reduced at each LOD.">VertexReductionQuota</a> quota = VRQ_PROPORTIONAL, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> reductionValue = 0.5f );
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="keyword">protected</span>:
<a name="l00113"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#234adc727c7bf50b18f201b68e664e85">00113</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *mpVertexData;
<a name="l00114"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#d712f5fffad66a568d465b2efdf2ebd0">00114</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> *mpIndexData;
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#b166495b3a0dc8f25d25485fa11dac0e">00116</a>         <span class="keywordtype">size_t</span> mCurrNumIndexes;
<a name="l00117"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#45c19ccc60bca019dfcd1eb7d6c5432d">00117</a>         <span class="keywordtype">size_t</span> mNumCommonVertices;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119         <span class="comment">// Internal classes</span>
<a name="l00120"></a>00120         <span class="keyword">class </span><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a>;
<a name="l00121"></a>00121         <span class="keyword">class </span><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123         <span class="keyword">public</span>: <span class="comment">// VC6 hack</span>
<a name="l00124"></a>00124 
<a name="l00127"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html">00127</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> {
<a name="l00128"></a>00128         <span class="keyword">public</span>:
<a name="l00129"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#25c686e910e4c1a9bba1e1305aba04ec">00129</a>             <span class="keywordtype">size_t</span> realIndex;
<a name="l00130"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html#0a498b8308e398baa49442f458f7acd5">00130</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* commonVertex;
<a name="l00131"></a>00131         };
<a name="l00132"></a>00132 
<a name="l00133"></a>00133         <span class="keyword">protected</span>:
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html">00136</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a> {
<a name="l00137"></a>00137         <span class="keyword">public</span>:
<a name="l00138"></a>00138             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html" title="A triangle in the progressive mesh, holds extra info like face normal.">PMTriangle</a>();
<a name="l00139"></a>00139             <span class="keywordtype">void</span> setDetails(<span class="keywordtype">size_t</span> index, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v0, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v1, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v2);
<a name="l00140"></a>00140             <span class="keywordtype">void</span> computeNormal(<span class="keywordtype">void</span>);
<a name="l00141"></a>00141             <span class="keywordtype">void</span> replaceVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *vold, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *vnew);
<a name="l00142"></a>00142             <span class="keywordtype">bool</span> hasCommonVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *v) <span class="keyword">const</span>;
<a name="l00143"></a>00143             <span class="keywordtype">bool</span> hasFaceVertex(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a> *v) <span class="keyword">const</span>;
<a name="l00144"></a>00144             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a>* getFaceVertexFromCommon(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* commonVert);
<a name="l00145"></a>00145             <span class="keywordtype">void</span> notifyRemoved(<span class="keywordtype">void</span>);
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#e1ae521198beb805fa9e29135898c9f7">00147</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMFaceVertex.html" title="A vertex as used by a face.">PMFaceVertex</a>* vertex[3]; <span class="comment">// the 3 points that make this tri</span>
<a name="l00148"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#2965fa7602c835772a2737c9fb5c5854">00148</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>   normal;    <span class="comment">// unit vector othogonal to this face</span>
<a name="l00149"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#5213866374d631850c409eabcbd94fb3">00149</a>             <span class="keywordtype">bool</span>      removed;   <span class="comment">// true if this tri is now removed</span>
<a name="l00150"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMTriangle.html#03f366aaa28888aa806556d2bb44e33a">00150</a>             <span class="keywordtype">size_t</span> index;
<a name="l00151"></a>00151         };
<a name="l00152"></a>00152 
<a name="l00159"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html">00159</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> {
<a name="l00160"></a>00160         <span class="keyword">public</span>:
<a name="l00161"></a>00161             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>();
<a name="l00162"></a>00162             <span class="keywordtype">void</span> setDetails(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v, <span class="keywordtype">size_t</span> index);
<a name="l00163"></a>00163             <span class="keywordtype">void</span> removeIfNonNeighbor(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *n);
<a name="l00164"></a>00164             <span class="keywordtype">bool</span> isBorder(<span class="keywordtype">void</span>);
<a name="l00165"></a>00165             <span class="keywordtype">bool</span> isManifoldEdgeWith(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a>* v); <span class="comment">// is edge this-&gt;src a manifold edge?</span>
<a name="l00166"></a>00166             <span class="keywordtype">void</span> notifyRemoved(<span class="keywordtype">void</span>);
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#b2c1e1bf8296736b1b426577cdd8a020">00168</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>  position;  <span class="comment">// location of point in euclidean space</span>
<a name="l00169"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#6982e31f211ee8b10cf643baebefc3aa">00169</a>             <span class="keywordtype">size_t</span> index;       <span class="comment">// place of vertex in original list</span>
<a name="l00170"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#c6ea70b4253024dc32be3d36e093e611">00170</a>             <span class="keyword">typedef</span> std::set&lt;PMVertex *&gt; NeighborList;
<a name="l00171"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#0bf8369fb608658e95480dc94a1d583e">00171</a>             <span class="keyword">typedef</span> std::set&lt;PMVertex *&gt; DuplicateList;
<a name="l00172"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#ba08b3a1f6c6618e71fca01f4c326684">00172</a>             NeighborList neighbor; <span class="comment">// adjacent vertices</span>
<a name="l00173"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#c4653133a44096bb3edfef99c4c06239">00173</a>             <span class="keyword">typedef</span> std::set&lt;PMTriangle *&gt; FaceList;
<a name="l00174"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#47b4d3d779f9e5323a24f53cf613a490">00174</a>             FaceList face;     <span class="comment">// adjacent triangles</span>
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#0bcc94cc31dc57068026c7a185baa589">00176</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> collapseCost;  <span class="comment">// cached cost of collapsing edge</span>
<a name="l00177"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#63fb8662dd40d265518a2c434e1e400b">00177</a>             <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> * collapseTo; <span class="comment">// candidate vertex for collapse</span>
<a name="l00178"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#75bbec5fa218bb9845b3f059b9cddab6">00178</a>             <span class="keywordtype">bool</span>      removed;   <span class="comment">// true if this vert is now removed</span>
<a name="l00179"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#d259bc95f91a0186b62d932d368bde57">00179</a>             <span class="keywordtype">bool</span>      toBeRemoved; <span class="comment">// denug</span>
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html#055efe6d7c72ddef5215588ab540fe63">00181</a>             <span class="keywordtype">bool</span> seam;  
<a name="l00182"></a>00182 
<a name="l00183"></a>00183         };
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#6de5d3d121da657332de44f0eda1689c">00185</a>         <span class="keyword">typedef</span> std::vector&lt;PMTriangle&gt; TriangleList;
<a name="l00186"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#b399d0958410761a3e40cc9b1ee79de0">00186</a>         <span class="keyword">typedef</span> std::vector&lt;PMFaceVertex&gt; FaceVertexList;
<a name="l00187"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#068c955d126c3329366627661cbf91ae">00187</a>         <span class="keyword">typedef</span> std::vector&lt;PMVertex&gt; CommonVertexList;
<a name="l00188"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#f3cb5af29550ccd45667aa9e8c0bab19">00188</a>         <span class="keyword">typedef</span> std::vector&lt;Real&gt; WorstCostList;
<a name="l00189"></a>00189 
<a name="l00191"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html">00191</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html" title="Data used to calculate the collapse costs.">PMWorkingData</a>
<a name="l00192"></a>00192         {
<a name="l00193"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#bc95718fbe89b15ac1dabdcbfc19cd56">00193</a>             TriangleList mTriList; 
<a name="l00194"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#e86f7159118c6ed73b2aef36c9aec3c0">00194</a>             FaceVertexList mFaceVertList; <span class="comment">// The vertex details referenced by the triangles</span>
<a name="l00195"></a><a class="code" href="structOgre_1_1ProgressiveMesh_1_1PMWorkingData.html#69bbfe9ac518ca8c9519c6de8673f8f3">00195</a>             CommonVertexList mVertList; <span class="comment">// The master list of common vertices</span>
<a name="l00196"></a>00196         };
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#ea9592c2ce2ad3f1006b892d03135162">00198</a>         <span class="keyword">typedef</span> std::vector&lt;PMWorkingData&gt; WorkingDataList;
<a name="l00200"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#d657f9004aabb5932753a429061b8ed7">00200</a>         WorkingDataList mWorkingData;
<a name="l00201"></a>00201 
<a name="l00203"></a><a class="code" href="classOgre_1_1ProgressiveMesh.html#efa2fb879e0989999c893e51c529d414">00203</a>         WorstCostList mWorstCosts;
<a name="l00204"></a>00204 
<a name="l00206"></a>00206         <span class="keywordtype">void</span> addWorkingData(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData, <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* indexData);
<a name="l00207"></a>00207 
<a name="l00209"></a>00209         <span class="keywordtype">void</span> initialiseEdgeCollapseCosts(<span class="keywordtype">void</span>);
<a name="l00211"></a>00211         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> computeEdgeCollapseCost(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *src, <a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *dest);
<a name="l00213"></a>00213         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> computeEdgeCostAtVertexForBuffer(WorkingDataList::iterator idata, <span class="keywordtype">size_t</span> vertIndex);
<a name="l00215"></a>00215         <span class="keywordtype">void</span> computeEdgeCostAtVertex(<span class="keywordtype">size_t</span> vertIndex);
<a name="l00217"></a>00217         <span class="keywordtype">void</span> computeAllCosts(<span class="keywordtype">void</span>);
<a name="l00219"></a>00219         <span class="keywordtype">size_t</span> getNextCollapser(<span class="keywordtype">void</span>);
<a name="l00221"></a>00221         <span class="keywordtype">void</span> bakeNewLOD(<a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* pData);
<a name="l00222"></a>00222 
<a name="l00229"></a>00229         <span class="keywordtype">void</span> collapse(<a class="code" href="classOgre_1_1ProgressiveMesh_1_1PMVertex.html" title="A vertex in the progressive mesh, holds info like collapse cost etc.">PMVertex</a> *collapser);
<a name="l00230"></a>00230 
<a name="l00232"></a>00232         <span class="keywordtype">void</span> dumpContents(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; log);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     };
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#endif </span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
